// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `FileParser.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package IceGrid;

/**
 * <tt>icegridadmin</tt> provides a {@link FileParser}
 * object to transform XML files into {@link ApplicationDescriptor}
 * objects.
 * 
 **/
public final class FileParserPrxHelper extends Ice.ObjectPrxHelperBase implements FileParserPrx
{
    private static final String __parse_name = "parse";

    /**
     * Parse a file.
     * 
     * @param xmlFile Full pathname to the file.
     * 
     * @param adminProxy An Admin proxy, used only to retrieve default
     * templates when needed. May be null.
     * 
     * @return The application descriptor.
     * 
     * @throws ParseException Raised if an error occurred during parsing.
     * 
     **/
    public ApplicationDescriptor parse(String xmlFile, AdminPrx adminProxy)
        throws ParseException
    {
        return parse(xmlFile, adminProxy, null, false);
    }

    /**
     * Parse a file.
     * 
     * @param xmlFile Full pathname to the file.
     * 
     * @param adminProxy An Admin proxy, used only to retrieve default
     * templates when needed. May be null.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The application descriptor.
     * 
     * @throws ParseException Raised if an error occurred during parsing.
     * 
     **/
    public ApplicationDescriptor parse(String xmlFile, AdminPrx adminProxy, java.util.Map<String, String> __ctx)
        throws ParseException
    {
        return parse(xmlFile, adminProxy, __ctx, true);
    }

    private ApplicationDescriptor parse(String xmlFile, AdminPrx adminProxy, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws ParseException
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "parse", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("parse");
                    __delBase = __getDelegate(false);
                    _FileParserDel __del = (_FileParserDel)__delBase;
                    return __del.parse(xmlFile, adminProxy, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Parse a file.
     * 
     * @param __cb The callback object for the operation.
     * @param xmlFile Full pathname to the file.
     * 
     * @param adminProxy An Admin proxy, used only to retrieve default
     * templates when needed. May be null.
     * 
     **/
    public Ice.AsyncResult begin_parse(String xmlFile, AdminPrx adminProxy)
    {
        return begin_parse(xmlFile, adminProxy, null, false, null);
    }

    /**
     * Parse a file.
     * 
     * @param __cb The callback object for the operation.
     * @param xmlFile Full pathname to the file.
     * 
     * @param adminProxy An Admin proxy, used only to retrieve default
     * templates when needed. May be null.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_parse(String xmlFile, AdminPrx adminProxy, java.util.Map<String, String> __ctx)
    {
        return begin_parse(xmlFile, adminProxy, __ctx, true, null);
    }

    /**
     * Parse a file.
     * 
     * @param __cb The callback object for the operation.
     * @param xmlFile Full pathname to the file.
     * 
     * @param adminProxy An Admin proxy, used only to retrieve default
     * templates when needed. May be null.
     * 
     **/
    public Ice.AsyncResult begin_parse(String xmlFile, AdminPrx adminProxy, Ice.Callback __cb)
    {
        return begin_parse(xmlFile, adminProxy, null, false, __cb);
    }

    /**
     * Parse a file.
     * 
     * @param __cb The callback object for the operation.
     * @param xmlFile Full pathname to the file.
     * 
     * @param adminProxy An Admin proxy, used only to retrieve default
     * templates when needed. May be null.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_parse(String xmlFile, AdminPrx adminProxy, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_parse(xmlFile, adminProxy, __ctx, true, __cb);
    }

    /**
     * Parse a file.
     * 
     * @param __cb The callback object for the operation.
     * @param xmlFile Full pathname to the file.
     * 
     * @param adminProxy An Admin proxy, used only to retrieve default
     * templates when needed. May be null.
     * 
     **/
    public Ice.AsyncResult begin_parse(String xmlFile, AdminPrx adminProxy, Callback_FileParser_parse __cb)
    {
        return begin_parse(xmlFile, adminProxy, null, false, __cb);
    }

    /**
     * Parse a file.
     * 
     * @param __cb The callback object for the operation.
     * @param xmlFile Full pathname to the file.
     * 
     * @param adminProxy An Admin proxy, used only to retrieve default
     * templates when needed. May be null.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_parse(String xmlFile, AdminPrx adminProxy, java.util.Map<String, String> __ctx, Callback_FileParser_parse __cb)
    {
        return begin_parse(xmlFile, adminProxy, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_parse(String xmlFile, AdminPrx adminProxy, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__parse_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __parse_name, __cb);
        try
        {
            __result.__prepare(__parse_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(xmlFile);
            AdminPrxHelper.__write(__os, adminProxy);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The application descriptor.
     * 
     **/
    public ApplicationDescriptor end_parse(Ice.AsyncResult __result)
        throws ParseException
    {
        Ice.AsyncResult.__check(__result, this, __parse_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(ParseException __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            ApplicationDescriptor __ret;
            __ret = new ApplicationDescriptor();
            __ret.__read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public static FileParserPrx checkedCast(Ice.ObjectPrx __obj)
    {
        FileParserPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof FileParserPrx)
            {
                __d = (FileParserPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    FileParserPrxHelper __h = new FileParserPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static FileParserPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        FileParserPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof FileParserPrx)
            {
                __d = (FileParserPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    FileParserPrxHelper __h = new FileParserPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static FileParserPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        FileParserPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    FileParserPrxHelper __h = new FileParserPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static FileParserPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        FileParserPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    FileParserPrxHelper __h = new FileParserPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static FileParserPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        FileParserPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof FileParserPrx)
            {
                __d = (FileParserPrx)__obj;
            }
            else
            {
                FileParserPrxHelper __h = new FileParserPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static FileParserPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        FileParserPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            FileParserPrxHelper __h = new FileParserPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::IceGrid::FileParser"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _FileParserDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _FileParserDelD();
    }

    public static void __write(IceInternal.BasicStream __os, FileParserPrx v)
    {
        __os.writeProxy(v);
    }

    public static FileParserPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            FileParserPrxHelper result = new FileParserPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
